import { URI } from '@vscode/monaco-editor/esm/vs/base/common/uri';
import { ICodeEditor, IDiffEditor } from '@vscode/monaco-editor/esm/vs/editor/browser/editorBrowser';
import { IDecorationRenderOptions } from '@vscode/monaco-editor/esm/vs/editor/common/editorCommon';
import { IModelDecorationOptions, ITextModel } from '@vscode/monaco-editor/esm/vs/editor/common/model';
import { IResourceEditorInput as IResourceInput } from '@vscode/monaco-editor/esm/vs/platform/editor/common/editor';
import { ICodeEditorService } from '@workbench-stack/core';
import { Event } from '@vscode/monaco-editor/esm/vs/base/common/event';
export declare class CodeEditorService implements ICodeEditorService {
    onDecorationTypeRegistered: Event<string>;
    resolveDecorationCSSRules(decorationTypeKey: string): CSSRuleList;
    setModelProperty(resource: URI, key: string, value: any): void;
    getModelProperty(resource: URI, key: string): void;
    getTransientModelProperties(model: ITextModel): [string, any][];
    addCodeEditor(editor: ICodeEditor): void;
    removeCodeEditor(editor: ICodeEditor): void;
    listCodeEditors(): readonly ICodeEditor[];
    addDiffEditor(editor: IDiffEditor): void;
    removeDiffEditor(editor: IDiffEditor): void;
    listDiffEditors(): readonly IDiffEditor[];
    getFocusedCodeEditor(): ICodeEditor | null;
    registerDecorationType(key: string, options: IDecorationRenderOptions, parentTypeKey?: string): void;
    removeDecorationType(key: string): void;
    resolveDecorationOptions(typeKey: string, writable: boolean): IModelDecorationOptions;
    setTransientModelProperty(model: ITextModel, key: string, value: any): void;
    getTransientModelProperty(model: ITextModel, key: string): any;
    getActiveCodeEditor(): ICodeEditor | null;
    openCodeEditor(input: IResourceInput, source: ICodeEditor | null, sideBySide?: boolean): Promise<ICodeEditor | null>;
}
